Gecode::Search::Engine Class Referenceabstract

Search engine implementation interface More...

`#include <search.hh>`

## Public Member Functions

virtual Space * | next (void)=0
| Return next solution (NULL, if none exists or search has been stopped).
virtual Statistics | statistics (void) const =0
| Return statistics.
virtual bool | stopped (void) const =0
| Check whether engine has been stopped.
virtual void | constrain (const Space &b)
| Constrain future solutions to be better than b (raises exception).
virtual void | reset (Space *s)
| Reset engine to restart at space s (does nothing).
virtual NoGoods & | nogoods (void)
| Return no-goods (the no-goods are empty).
virtual | ~Engine (void)
| Destructor.

## Additional Inherited Members

Static Public Member Functions inherited from Gecode::HeapAllocated
static void * | operator new (size_t s)
| Memory management.
static void | operator delete (void *p)
| Free memory allocated from heap.

## Detailed Description

Search engine implementation interface

Definition at line 899 of file search.hh.

## Constructor & Destructor Documentation

## ~Engine()

Gecode::Search::Engine::~Engine | ( | void |  | ) |

inline virtual

Destructor.

Definition at line 37 of file engine.hpp.

## Member Function Documentation

## next()

virtual Space * Gecode::Search::Engine::next | ( | void |  | ) |

pure virtual

Return next solution (NULL, if none exists or search has been stopped).

Implemented in Gecode::Search::Par::Engine< Tracer >, Gecode::Search::Par::PBS< Collect >, Gecode::Search::Par::PBS< Gecode::Search::Par::CollectBest >, Gecode::Search::Seq::Dead< Tracer >, Gecode::Search::Seq::LDS< Tracer >, Gecode::Search::Seq::PBS< best >, Gecode::Search::Seq::RBS, and Gecode::Search::WorkerToEngine< Worker >.

## statistics()

virtual Statistics Gecode::Search::Engine::statistics | ( | void |  | ) | const

pure virtual

Return statistics.

Implemented in Gecode::Search::Par::BAB< Tracer >, Gecode::Search::Par::DFS< Tracer >, Gecode::Search::Par::PBS< Collect >, Gecode::Search::Par::PBS< Gecode::Search::Par::CollectBest >, Gecode::Search::Seq::Dead< Tracer >, Gecode::Search::Seq::LDS< Tracer >, Gecode::Search::Seq::PBS< best >, Gecode::Search::Seq::RBS, and Gecode::Search::WorkerToEngine< Worker >.

## stopped()

virtual bool Gecode::Search::Engine::stopped | ( | void |  | ) | const

pure virtual

Check whether engine has been stopped.

Implemented in Gecode::Search::Par::Engine< Tracer >, Gecode::Search::Par::PBS< Collect >, Gecode::Search::Par::PBS< Gecode::Search::Par::CollectBest >, Gecode::Search::Seq::Dead< Tracer >, Gecode::Search::Seq::LDS< Tracer >, Gecode::Search::Seq::PBS< best >, Gecode::Search::Seq::RBS, and Gecode::Search::WorkerToEngine< Worker >.

## constrain()

void Gecode::Search::Engine::constrain | ( | const Space & | b | ) |

virtual

Constrain future solutions to be better than b (raises exception).

Reimplemented in Gecode::Search::Par::BAB< Tracer >, Gecode::Search::Par::PBS< Collect >, Gecode::Search::Par::PBS< Gecode::Search::Par::CollectBest >, Gecode::Search::Seq::LDS< Tracer >, Gecode::Search::Seq::PBS< best >, Gecode::Search::Seq::RBS, and Gecode::Search::WorkerToEngine< Worker >.

Definition at line 39 of file engine.cpp.

## reset()

void Gecode::Search::Engine::reset | ( | Space * | s | ) |

virtual

Reset engine to restart at space s (does nothing).

Reimplemented in Gecode::Search::Par::BAB< Tracer >, Gecode::Search::Par::DFS< Tracer >, Gecode::Search::Seq::LDS< Tracer >, and Gecode::Search::WorkerToEngine< Worker >.

Definition at line 44 of file engine.cpp.

## nogoods()

NoGoods & Gecode::Search::Engine::nogoods | ( | void |  | ) |

virtual

Return no-goods (the no-goods are empty).

Reimplemented in Gecode::Search::Par::BAB< Tracer >, Gecode::Search::Par::DFS< Tracer >, and Gecode::Search::WorkerToEngine< Worker >.

Definition at line 48 of file engine.cpp.

The documentation for this class was generated from the following files:

- gecode/search.hh
- gecode/search/engine.cpp
- gecode/search/engine.hpp